<template>
  <!-- Input Dialog -->
  <q-dialog v-model="inputDialog" :maximized="true">
    <q-card>
      <q-card-section class="row items-center q-pb-none">
        <div class="text-h5">{{ title }}</div>
        <q-space></q-space>
        <q-btn dense flat v-close-popup>
          <q-icon name="close"></q-icon>
        </q-btn>
      </q-card-section>
      <q-card-section class="q-gutter-md">
        <q-input label="Title" v-model="data.title"></q-input>
        <q-select
          filled
          :model-value="data.genre"
          use-input
          hide-selected
          fill-input
          input-debounce="500"
          :options="options"
          @filter="genreFilter"
          @input-value="setModel"
          hint="Genre"
        >
          <template v-slot:no-option>
            <q-item>
              <q-item-section class="text-grey"> No results </q-item-section>
            </q-item>
          </template>
        </q-select>
        <q-input label="Description" v-model="data.description" />
        <q-editor v-model="data.content" />
        <q-select
          label="Status"
          v-model="data.status"
          :options="['draft', 'publish']"
        />
        <q-btn color="green" @click="saveData" v-close-popup>Simpan</q-btn>
      </q-card-section>
    </q-card>
  </q-dialog>

  <!-- Delete Dialog -->
  <q-dialog v-model="deleteDialog">
    <q-card>
      <q-card-section class="row items-center">
        <q-avatar icon="delete" color="red" text-color="white" />
        <span class="q-ml-sm"> Yakin ingin hapus? </span>
      </q-card-section>
      <q-card-actions align="right">
        <q-btn flat label="Batal" color="primary" v-close-popup />
        <q-btn
          flat
          label="Hapus"
          color="primary"
          v-close-popup
          @click="deleteItem"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>

  <!-- Actual Page -->
  <admin-page-template
    title="Blog Management"
    :breadcrumbs="['Dashboard', 'Game']"
  >
    <div class="q-pa-md row">
      <div class="col-md-9 col-xs-12">
        <q-input
          :debounce="500"
          color="purple"
          outlined
          label="Pencarian"
          v-model="store.search"
          @update:model-value="store.fetchItems()"
        >
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>
      </div>
      <div class="col-md-3 col-xs-12">
        <q-btn color="primary" class="float-right" @click="openInputDialog()">
          + {{ title }}
        </q-btn>
      </div>
    </div>
    <div v-if="store.count > 0">
      <q-pagination
        v-model="store.page"
        class="q-ma-md"
        :max="Math.ceil(store.count / store.limit)"
        :max-pages="9"
        direction-links
        @update:model-value="store.fetchItems()"
      />
      <div class="q-pa-md q-ma-sm" v-for="item in store.items" :key="item.id">
        <q-card>
          <q-card-section>
            <div class="row">
              <div class="col-md-3 col-xs-12">
                <q-img
                  src="https://cdn.quasar.dev/img/mountains.jpg"
                  ratio="1.5"
                ></q-img>
              </div>
              <div class="col-md-6 col-xs-12 q-pa-md">
                <div class="text-h6">{{ item.title }}</div>
                <div>
                  <q-badge color="orange">{{ item.genre }}</q-badge>
                  <q-badge>{{ item.status }}</q-badge>
                </div>
                <div>{{ item.description }}</div>
                <div>Author : {{ item.author }}</div>
                <div>{{ item.created_at }}</div>
              </div>
              <div class="col-md-3 col-xs-12 q-pa-md">
                <q-btn class="float-right" flat @click="openDeleteDialog(item)">
                  <q-icon name="delete" color="red"></q-icon>
                </q-btn>
                <q-btn class="float-right" flat @click="openInputDialog(item)">
                  <q-icon name="edit" color="orange"></q-icon>
                </q-btn>
              </div>
            </div>
          </q-card-section>
        </q-card>
      </div>
      <q-pagination
        v-model="store.page"
        class="q-ma-md"
        :max="Math.ceil(store.count / store.limit)"
        :max-pages="9"
        direction-links
        @update:model-value="store.fetchItems()"
      />
    </div>
    <div v-else class="q-pa-md">Kosong</div>
  </admin-page-template>
</template>

<script>
import { ref } from 'vue';
import { useAdminGamesStore } from 'stores/admin-games';
import { useAdminGenresStore } from 'stores/admin-genre';
import { useAdminStore } from 'stores/admin';
import { generateCommonDialogState } from './_stateGenerator';
import AdminPageTemplate from 'src/components/AdminPageTemplate.vue';

export default {
  name: 'GameAdminPage',

  components: { AdminPageTemplate },
  setup() {
    const title = 'Game';
    const user = useAdminStore();
    const store = useAdminGamesStore();
    const genres = useAdminGenresStore();
    genres.fetchItems();
    store.fetchItems();
    const options = ref([]);
    const data = ref({
      id: 0,
      slug: '',
      title: '',
      genre: '',
      description: '',
      thumbnail: '',
      content: '',
      status: 'draft',
      user_id: user.id,
    });

    return {
      title,
      store,
      data,
      options,
      ...generateCommonDialogState(data, store),
      genreFilter(val, update) {
        update(() => {
          const needle = val.toLocaleLowerCase();
          options.value = genres.items
            .map((c) => c.name)
            .filter((c) => c.toLocaleLowerCase().indexOf(needle) > -1);
        });
      },
      setModel(val) {
        data.value.genre = val;
      },
    };
  },
};
</script>
